import pygame, sys
from pygame.locals import *
"""das Sprite für den Spieler"""
class _Player_(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y, scale, speed, jump_speed, jump_d, x, y):
        super().__init__()
        self.right1 = pygame.image.load("sprites/right1.png")
        self.right2 = pygame.image.load("sprites/right2.png")
        self.static = pygame.image.load("sprites/static.png")
        self.left1 = pygame.image.load("sprites/left1.png")
        self.left2 = pygame.image.load("sprites/left2.png")
        self.jump_right = pygame.image.load("sprites/jump_right.png")
        self.jump_left = pygame.image.load("sprites/jump_left.png")
        self.right_images = [self.right1, self.right2]
        self.left_images = [self.left1, self.left2]
        self.jump_images = [self.jump_left, self.jump_right]
        self.run_right_img = 1
        self.run_left_img = 1
        self.image = self.static
        self.image = pygame.transform.scale(self.image, (scale, scale))
        self.img = 1
        self.rect = self.image.get_rect()
        self.pos_x = pos_x
        self.pos_y = pos_y
        self.scale = scale
        self.rect.x = self.pos_x
        self.rect.y = self.pos_y
        self.x = x
        self.y = y
        self.old_x = x
        self.old_y = y
        self.is_running = True
        self.jump = False
        self.animation_steps = 0.11
        self.speed = speed
        self.jump_speed = jump_speed
        self.old_jump_speed = jump_speed
        self.jump_height = 200
        self.old_jump_height = self.jump_height
        self.ground = self.pos_y
        self.gravity = 10
        self.grav = False
        self.jump_y = self.pos_y
        self.spaceup = True
        self.game = None
        self.check_x = 60
        self.check_y = int(self.scale/2)+40
        self.direction = ""
        self.jump_direction = ""
        self.jump_r = jump_d
        self.old_jump_r = self.jump_r
        self.collide = 1
    """wenn das level neu gestartet wird"""
    def reset(self):
        self.rect.x = self.pos_x
        self.rect.y = self.pos_y
        self.x = self.old_x
        self.y = self.old_y
        self.ground = self.pos_y
        self.jump_height = self.ground-self.old_jump_height
    """Bewegung nach oben, wenn gesprungen wird"""
    def jump_(self):
        if self.jump == True:
            if self.jump_speed > 0.5:
                self.rect.y -= int(self.jump_speed)
                self.y -= int(self.jump_speed)/self.game.pixel
                self.jump_speed *= 0.9
                if self.direction == "right":
                    if (self.rect.x+self.jump_r) < self.game.width:
                        self.rect.x += int(self.jump_r)
                        self.x += int(self.jump_r)/self.game.pixel
                        if self.jump_r < 5:
                            self.jump_r *= 1.2
                elif self.direction == "left":
                    if (self.rect.x-self.jump_r) > 0:
                        self.rect.x -= int(self.jump_r)
                        self.x -= int(self.jump_r)/self.game.pixel
                        if self.jump_r < 5:
                            self.jump_r *= 1.2
                elif self.direction == "":
                    self.jump_r = 0
            else:
                self.jump = False
                print("jump")
    """Blöcke um den Spieler herum werden abgefragt"""
    def check_hitbox(self):
        ground = False
        if self.direction == "right":
            self.collide = 2
        elif self.direction == "left":
            self.collide = 2
        for tile in self.game.tiles:
            """der Boden wird erkannt"""
            if tile.type == 3:
                if tile.x == int(self.x)+self.collide or tile.x == int(self.x)+1:
                    if tile.y == int(self.y):
                        """die Schwerkraft wird aufgehoben, wenn der Spieler auf festem Boden steht"""
                        if self.ground != self.rect.y:
                            self.ground = (tile.y-1)*self.game.pixel-50
                            self.rect.y = self.ground
                        """die Geschwindigkeit des Spielers richtet sich nach dem Boden aus"""
                        if tile.speed != self.speed:
                            self.speed = tile.speed
                        ground = True
                        if self.direction == "":
                            self.image = self.static
                            self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
            """ein neues Level wird geladen, wenn der Spieler ins Ziel läuft"""
            if tile.type == 4:
                if tile.x == int(self.x)+2 or tile.x == int(self.x)+1:
                    if tile.y == int(self.y)-1:
                        self.game.all_sprites.remove(self)
                        self.reset()
                        if self.game.level != len(self.game.levels.levels):
                            self.game.level+=1
                        else:
                            self.game.level = 1
                        self.game.start_level()
        if ground == False:
            self.ground += self.game.pixel
        if self.rect.y != self.ground:
            if self.direction == "right":
                if self.rect.x < self.game.width:
                    if self.jump_direction == "left":
                        self.jump_direction = "right"
                        self.image = self.jump_images[1]
                        self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
            elif self.direction == "left":
                 if self.jump_direction == "right":
                    self.jump_direction = "left"
                    self.image = self.jump_images[0]
                    self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
        if self.rect.y == self.ground:
            self.grav = False
        elif self.rect.y < self.ground:
            self.grav = True
    """die Schwerkraft"""
    def gravitation(self):
        if self.grav == True:
            if self.rect.y < self.ground:
                self.rect.y += self.gravity
                self.y += self.gravity/self.game.pixel
            else:
                if self.rect.y != self.ground:
                    self.rect.y = self.ground      
                    self.y = int(self.y)
    """Tastenabfrage und Bewegung"""                
    def movement(self, keys):
        if self.rect.y == self.ground:
            self.jump_r = self.old_jump_r
            self.jump_speed = self.old_jump_speed
            """Bewegung nach rechts"""
            if keys[pygame.K_d] or keys[pygame.K_RIGHT]:
                self.direction = "right"
                if self.rect.y == self.ground:
                    if self.run_right_img < 2:
                        img = int(self.run_right_img)
                        self.run_right_img += self.animation_steps
                        if img != int(self.run_right_img):
                            if self.jump == False:
                                self.image = self.right_images[int(self.run_right_img) - 1]
                                self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                    else:
                        self.run_right_img = 0
                        self.image = self.right_images[int(self.run_right_img) - 1]
                        self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                """es wird überprüft, ob der Spieler laufen darf"""
                if self.rect.x < self.game.width:
                    collide = False
                    for tile in self.game.tiles:
                        if tile.type == 3:
                            if tile.x == int(self.x)+2:
                                if tile.y == int(self.y)-1:
                                    collide = True
                    aslant = False
                    for tile in self.game.tiles:
                        if tile.type == 2:
                            if tile.x == int(self.x)+2 or tile.x == int(self.x)+1:
                                if tile.y == int(self.y)-1:
                                    aslant = True
                    if collide == False:
                        if aslant == False:
                            self.rect.x += self.speed
                            self.x += self.speed/self.game.pixel
                        else:
                            self.rect.x += self.speed
                            self.rect.y -= self.speed
                            self.x += self.speed/self.game.pixel
                            self.y -= self.speed/self.game.pixel
            """Bewegung nach links"""
            if keys[pygame.K_a] or keys[pygame.K_LEFT]:
                self.direction = "left"
                if self.rect.y == self.ground:
                    if self.run_left_img < 2:
                        img = int(self.run_left_img)
                        self.run_left_img += self.animation_steps
                        if img != int(self.run_left_img):
                            if self.jump == False:
                                self.image = self.left_images[int(self.run_left_img)-1]
                                self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                    else:
                        self.run_left_img = 0
                        if self.jump == False:
                            self.image = self.left_images[int(self.run_left_img) - 1]
                            self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                """es wird überprüft, ob der Spieler laufen darf"""
                if self.rect.x > 0:
                    collide = False
                    for tile in self.game.tiles:
                        if tile.type == 3:
                            if tile.x == int(self.x):
                                if tile.y == int(self.y)-1:
                                    collide = True
                    if collide == False:
                        self.rect.x -= self.speed
                        self.x -= self.speed/self.game.pixel
            """der Sprung"""
            if keys[pygame.K_SPACE]:
                if self.rect.y == self.ground:
                    self.jump_direction = self.direction	
                    if self.direction == "right":
                        self.img = 2
                        self.image = self.jump_images[1]
                        self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                    elif self.direction == "left":
                        self.img = 2
                        self.image = self.jump_images[0]
                        self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
                    if self.spaceup == True:
                        self.jump = True
                        self.spaceup = False
            elif keys[pygame.K_SPACE] == False:
                self.spaceup = True
    def update(self):
        """die Tasten werden abgefragt"""
        keys = pygame.key.get_pressed()
        """die Funktionen werden ausgeführt"""
        if self.rect.y == self.ground:
            self.jump = False
            if self.img == 2:
                self.img = 1
                self.image = self.static
                self.direction = ""
                self.image = pygame.transform.scale(self.image, (self.scale, self.scale))
            self.jump_height = (self.ground-self.old_jump_height)
        self.movement(keys)
        self.check_hitbox()
        self.jump_()
        self.gravitation()
if __name__ == "__main__":
    sys.exit()