from tkinter import *
import pygame, sys
from pygame.locals import *
import time
import keyboard
from levels import Levels
from Player import _Player_
from tile import _Tile_
from colors import colors
pygame.init()
"""""die Game Klasse organisiert alle Fenster"""
class Game():
    def __init__(self):
        self.state = 0
        self.menu = None
        self.options = None
        self.options_possible = True
        self.statistics = None
        self.statistics_possible = True
        self.window = None
        self.button = True
        self.width = 700
        self.height = 550
        self.level = 1
        self.levels = Levels()
        self.player = None
        self.normal_speed = 5
        self.all_sprites = pygame.sprite.Group()
        self.background_sprites = pygame.sprite.Group()
        self.fill_color = None
        self.pixel = self.levels.pixel
        self.tiles = []
    def clear_window(self):
        self.tiles.clear()
        self.all_sprites.empty()
        self.background_sprites.empty()
        self.window.fill(colors.lightblue)
    def start_level(self):
        self.clear_window()
        player_x = 0
        player_y = 0
        player_scale = 80
        """die level strings werden abgefragt und die Blöcke werden im Raster gezeichnet"""
        for y in range(0, self.levels.len_y):
            for x in range(0, self.levels.len_x):
                matrix = (self.levels.levels[self.level-1])[y][x]
                """
                Typ1: Dekoration
                Typ2: Erhöhung
                Typ3: Boden
                Typ4: Ziel
                """
                """Grasblock"""
                if matrix == "g":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/grass1.png"), 3, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Erdblock"""
                if matrix == "d":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/dirt.png"), 3, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Erhöhung"""
                if matrix == "+":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/grass2.png"), 2, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Wolke"""
                if matrix == "c":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel*2, pygame.image.load("sprites/cloud1.png"), 1, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Blumen"""
                if matrix == "f":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/flowers.png"), 1, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Levelziel"""
                if matrix == "e":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/arrow.png"), 4, x, y, self.normal_speed)
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Sandblock"""
                if matrix == "s":
                    self.tile = _Tile_(x*self.levels.pixel, y*self.levels.pixel, self.levels.pixel, pygame.image.load("sprites/sand.png"), 3, x, y, int(self.normal_speed/1.5))
                    self.background_sprites.add(self.tile)
                    self.tiles.append(self.tile)
                """Spieler"""
                if matrix == "p":
                    player_x = x*self.levels.pixel
                    player_y = y*self.levels.pixel
                    player_x_pixel = x
                    player_y_pixel = y
        self.player = _Player_(player_x, player_y-50, player_scale, self.normal_speed, 35, 1, player_x_pixel, player_y_pixel)
        self.player.game = self
        self.all_sprites.add(self.player)
        self.state = 2
    """Organisation für den Spielstart"""
    def start(self):
        self.level = 1
        self.all_sprites.empty()
        self.background_sprites.empty()
        if self.button == True:
            self.menu.destroy()
        else:
            self.button = True
        """das Spielfenster"""
        self.window = pygame.display.set_mode((self.levels.len_x*self.levels.pixel, self.levels.len_y*self.levels.pixel))
        pygame.display.set_caption("runner - level: "+str(self.level))
        self.start_level()
    """wenn das Menü geschlossen wird"""
    def options_closed(self):
        self.options.destroy()
        self.options_possible = True
    """das Optionen Menü"""
    def open_options(self):
        if self.options_possible == True:
            self.options_possible = False
            self.options = Tk()
            self.options.resizable(0, 0)
            self.options.geometry("350x400")
            self.options.title("runner - options")
            self.options.protocol("WM_DELETE_WINDOW", self.options_closed)
            self.options.mainloop()
    """wenn die Statistiken geschlossen werden"""
    def statistics_closed(self):
        self.statistics.destroy()
        self.statistics_possible = True
    """das Statistiken Menü"""
    def open_statistics(self):
        if self.statistics_possible == True:
            self.statistics_possible = False
            self.statistics = Tk()
            self.statistics.resizable(0, 0)
            self.statistics.geometry("350x400")
            self.statistics.title("runner - statistics")
            self.statistics.protocol("WM_DELETE_WINDOW", self.statistics_closed)
            self.statistics.mainloop()
    """das Programm wird beendet wenn quit aufgerufen wird"""
    def quit(self):
        sys.exit()
    """das Hauptmenü"""
    def open_menu(self):
        self.menu = Tk()
        self.menu.resizable(0, 0)
        self.menu.geometry("350x400")
        self.menu.title("runner - menu")
        self.menu_canvas = Canvas(self.menu, bg="white", width=360, height=400)
        self.button_start = Button(self.menu, text="Start", fg="black", bg="green", activebackground="white", width=40, height=3, command=self.start)
        self.button_options = Button(self.menu, text="Options", fg="black", bg="green", activebackground="white", width=40, height=3, command=self.open_options)
        self.button_statistics = Button(self.menu, text="Statistics", fg="black", bg="green", activebackground="white", width=40, height=3, command=self.open_statistics)
        self.button_exit = Button(self.menu, text="Quit", fg="black", bg="green", activebackground="white", width=40, height=3, command=self.quit)
        self.menu_canvas.place(x=-10, y=0)
        self.button_options.place(x=175, y=75, anchor=CENTER)
        self.button_start.place(x=175, y=150, anchor=CENTER)
        self.button_statistics.place(x=175, y=225, anchor=CENTER)
        self.button_exit.place(x=175, y=300, anchor=CENTER)
        self.menu.mainloop()
    """die update Funktion sorgt dafür, dass das Menü geöffnet wird"""
    def update(self):
        if self.state == 0:
            self.state = 1
            self.open_menu()
game = Game()
if __name__ == "__main__":
    sys.exit()
